import _extends from "@babel/runtime/helpers/esm/extends";
import omit from 'lodash.omit';
import { reservedEventOrderField } from '../constants';
export var prepareEvents = function prepareEvents(events, context) {
  var timestamp = Date.now() + 60 * 1000;
  var order = 0;
  var aggregateVersionsMap = new Map();
  return events.map(function (testEvent) {
    var _extends2;

    var aggregateId = testEvent.aggregateId != null ? testEvent.aggregateId : context == null ? void 0 : context.aggregateId;
    var aggregateVersion = aggregateVersionsMap.has(aggregateId) ? aggregateVersionsMap.get(aggregateId) + 1 : 1;

    var event = _extends({}, testEvent, {
      aggregateId: aggregateId,
      aggregateVersion: aggregateVersion,
      timestamp: timestamp++,
      payload: _extends({}, testEvent.payload, (_extends2 = {}, _extends2[reservedEventOrderField] = order++, _extends2))
    });

    aggregateVersionsMap.set(aggregateId, aggregateVersion);
    return event;
  });
};
export var stripEvents = function stripEvents(events) {
  return events.sort(function (a, b) {
    return a.payload[reservedEventOrderField] - b.payload[reservedEventOrderField];
  }).map(function (event) {
    return _extends({}, event, {
      payload: _extends({}, omit(event.payload, reservedEventOrderField))
    });
  });
};
//# sourceMappingURL=events-utils.js.map